#!/usr/bin/env python

import os,sys,time,socket,threading,copy,StringIO,cPickle,subprocess,fcntl,struct,signal,shutil

class cGlobalData:
	pass


gd=cGlobalData()

def main():
	global gd
	gd.isTest=False
	gd.longbit=32
	
	gd.iStepAll=10
	gd.iStepNow=0

	sOut,sErr = fPopen("getconf LONG_BIT")
	if( int(sOut) == 32):
		print "getconf LONG_BIT = ",int(sOut)
		gd.longbit=32
	else :
		print "getconf LONG_BIT = ",int(sOut)
		gd.longbit=64


	if( len(sys.argv) > 1 ):
		if(sys.argv[1] == "test"):
			gd.isTest = True

	if(not initGD()):
		doExit()

	print "step "+stepnow()+"/"+str(gd.iStepAll),", checking os release version..."

	#auto find os release version		
	sOut,sErr = fPopen("cat /etc/issue")
	sIssueRes = sOut.lower()
	iSelect = 0
	idxArrOs=1
	while( idxArrOs <=4 ):
		if( sIssueRes.find(gd.arrOsDes[idxArrOs]) != -1):
			iSelect = idxArrOs
			break
		else:
			idxArrOs += 1

	#manually set os release version
	if( iSelect > 4 or iSelect<1 ):
		print ("%s")%(gd.sInstallTip)
		inSelect=raw_input()
		while( not inSelect.isdigit() or  int(inSelect) > 5 or int(inSelect) < 1):
			print ("%s")%(gd.sInstallTip)
			inSelect=raw_input()
		iSelect = int(inSelect)
		if( iSelect > 4 or iSelect<1 ):
			doExit()
	print "your os %s"%gd.arrOs[iSelect]

	print "step "+stepnow()+"/"+str(gd.iStepAll),", check app needed..."

	#print gd.arrApplist
	for sApp in gd.arrApplist:
		sOut,sErr = fPopen("which %s"%sApp)
		#print "sOut=<"+sOut+">"
		#print "sErr=<"+sErr+">"
		if( len(sOut) == 0 ):
			print "need "+sApp+" to install safedog for linux."
			print "installing exiting!"
			doExit()

	print "step "+stepnow()+"/"+str(gd.iStepAll),", making dir..."

	arrDirs2Make=["/etc/safedog/dmp","/etc/safedog/backup","/etc/safedog/monitor","/etc/safedog/update","/usr/lib/safedog","/usr/lib/udcenter"]
	for sDir in arrDirs2Make:
		try:
			os.makedirs(sDir,0700)
		except:
			#print "make directory:%s some error"%sDir
			pass

		if( not os.path.isdir(sDir)  ):
			print "create directory:'%s' failed!"%sDir
			print "installing exiting!"
			doExit()

	print "step "+stepnow()+"/"+str(gd.iStepAll),", installing file..."

	for sCmd in gd.arrCmds:
		sOut,sErr=fPopen(sCmd)
		if( len(sErr) >0 ):
			print "command:'%s' failed!"%sCmd
			print sErr
			doExit()

	print "step "+stepnow()+"/"+str(gd.iStepAll),", start safedog service..."
	fPopen("/usr/bin/sdstart")
	fPopen("killall udcenter >/dev/null 2>&1")
	print "step "+stepnow()+"/"+str(gd.iStepAll),", start safedog update service..."
	fPopen("udcenter")
	print "step "+stepnow()+"/"+str(gd.iStepAll),", save safedog install info..."
	if (gd.isTest ==  True):
		fPopen("udinstall test")
	else:
		fPopen("udinstall")

	print "step "+stepnow()+"/"+str(gd.iStepAll),", setting os release version..."
	print fPopen("sdcmd os %s"%gd.arrOs[iSelect])[0]
	print "step "+stepnow()+"/"+str(gd.iStepAll),", setting safedog version..."
	print fPopen("sdcmd ver %s"%gd.sVersion)[0]

	fPopen("sdcmd ddostcpsyncalctime 10")
	fPopen("sdcmd ddosproxymaxcalctime 60")
	fPopen("sdcmd ddosurlfollowcalctime 300")
	fPopen("sdcmd ddosdenytimelen 9000")

	print "step "+stepnow()+"/"+str(gd.iStepAll),", ok!"

	print "Congratulations! Safedog For Linux has been installed completely!"
	print "you can run the command below to setup safedog:"
	print "sdui\n"


	return



def doExit():
	if (gd.isTest ==  True):
		fPopen("./uninstall.py test")
	else:
		fPopen("./uninstall.py")

	sys.exit(1)
	return





def fPopen(aCmd):
	p=subprocess.Popen(aCmd, shell=True, bufsize=4096,stdin=subprocess.PIPE, stdout=subprocess.PIPE, stderr=subprocess.PIPE, close_fds=True)
	sOut = p.stdout.read()
	sErr = p.stderr.read()
	return (sOut,sErr)




def initGD():
	global gd
	gd.filelibcryptopath = ""
	gd.filelibsslpath = ""
	#find libcrypto and libssl and make links		
	if( gd.longbit == 64  ):
		gd.filelibcryptopath = findcrypto64()
	if( len(gd.filelibcryptopath) < 8):
		gd.filelibcryptopath = findcrypto()
	if( len(gd.filelibcryptopath) < 8):
		print "need libcrypto.so to install safedog for linux."
		print "installing exiting"
		return False
	
	if( gd.longbit == 64  ):
		gd.filelibsslpath = findssl64()
	if( len(gd.filelibsslpath) < 8):
		gd.filelibsslpath = findssl()
	if( len(gd.filelibsslpath) < 8):
		print "need libssl.so to install safedog for linux."
		print "installing exiting"
		return False

	print "find libcrypto.so:"+gd.filelibcryptopath
	print "find libssl.so:"+gd.filelibsslpath


	gd.sVersion="2.1.10001"
	gd.arrOs=['','ubuntu','centos','fedora','rhel','else']
	gd.arrOsDes=['','ubuntu','centos','fedora','hat','else']
	gd.sInstallTip="please select the correct release version name of your os:\n"
	gd.sInstallTip+="[1] ubuntu\n"
	gd.sInstallTip+="[2] centos\n"
	gd.sInstallTip+="[3] fedora\n"
	gd.sInstallTip+="[4] rhel (Red Hat Enterprise Linux)\n"
	gd.sInstallTip+="[5] else or I don't know\n"

	gd.arrApplist="python cat grep egrep awk netstat df free iptables zcat ifconfig sort uniq head hostname cp echo touch ps bash tail vmstat du mv tar mkdir rm chown chmod service killall kill ifdown ifup sed basename date uname ls cut diff iptables-save iptables-restore".split()

	gd.arrCmds=[]
	gd.arrCmds.append("chmod -R 700 ./*")
	gd.arrCmds.append("chmod +x ./dependpkg/lib/*")
	gd.arrCmds.append("chmod +x ./dependpkg/bin/* ")
	gd.arrCmds.append("chmod +x ./dependpkg/script/* ")
	gd.arrCmds.append("sdcmd exit >/dev/null 2>&1 &")
	gd.arrCmds.append("sleep 3")
	gd.arrCmds.append("killall sdcmd >/dev/null 2>&1")
	gd.arrCmds.append("killall sdsvrd >/dev/null 2>&1")

	gd.arrCmds.append("cp -a -f -r ./dependpkg/bin/sdsvrd /etc/safedog/dmp/")
	gd.arrCmds.append("cp -a -f -r ./dependpkg/lib/libsafedog/* /usr/lib/safedog/")
	gd.arrCmds.append("cp -a -f -r -P ./dependpkg/lib/libudcenter/* /usr/lib/udcenter/")
	gd.arrCmds.append("cp -a -f ./dependpkg/bin/* /usr/bin/")
	gd.arrCmds.append("cp -a -f ./dependpkg/script/* /usr/bin/")
	gd.arrCmds.append("cp -a -f ./dependpkg/trust.crt /etc/safedog/")
	gd.arrCmds.append("cp -a -f ./dependpkg/safedog.csf /etc/safedog/")
	gd.arrCmds.append("cp -a -f ./dependpkg/safedog_normal.psf /etc/safedog/")
	gd.arrCmds.append("cat ./dependpkg/spider.dat >> /etc/safedog/spider.dat")
	gd.arrCmds.append("sort /etc/safedog/spider.dat >> /etc/safedog/spider.dat.tmp")
	gd.arrCmds.append("uniq /etc/safedog/spider.dat.tmp > /etc/safedog/spider.dat")
	gd.arrCmds.append("rm -rf /etc/safedog/spider.dat.tmp")


	gd.arrCmds.append("cp -a -f ./dependpkg/script/safedog /etc/init.d/")
	gd.arrCmds.append("cp -a -f ./dependpkg/script/sdboot  /etc/init.d/")

	gd.arrCmds.append("rm -f /etc/rc2.d/S99sdboot")
	gd.arrCmds.append("rm -f /etc/rc3.d/S99sdboot")
	gd.arrCmds.append("rm -f /etc/rc4.d/S99sdboot")
	gd.arrCmds.append("rm -f /etc/rc5.d/S99sdboot")
	gd.arrCmds.append("ln -s /etc/init.d/sdboot /etc/rc2.d/S99sdboot")
	gd.arrCmds.append("ln -s /etc/init.d/sdboot /etc/rc3.d/S99sdboot")
	gd.arrCmds.append("ln -s /etc/init.d/sdboot /etc/rc4.d/S99sdboot")
	gd.arrCmds.append("ln -s /etc/init.d/sdboot /etc/rc5.d/S99sdboot")

	gd.arrCmds.append("cp -a -f ./dependpkg/script/udboot  /etc/init.d/")
	gd.arrCmds.append("rm -rf /etc/rc2.d/S99udboot")
	gd.arrCmds.append("rm -rf /etc/rc3.d/S99udboot")
	gd.arrCmds.append("rm -rf /etc/rc4.d/S99udboot")
	gd.arrCmds.append("rm -rf /etc/rc5.d/S99udboot")
	gd.arrCmds.append("ln -s /etc/init.d/udboot /etc/rc2.d/S99udboot")
	gd.arrCmds.append("ln -s /etc/init.d/udboot /etc/rc3.d/S99udboot")
	gd.arrCmds.append("ln -s /etc/init.d/udboot /etc/rc4.d/S99udboot")
	gd.arrCmds.append("ln -s /etc/init.d/udboot /etc/rc5.d/S99udboot")


	gd.arrCmds.append("rm -f /usr/lib/safedog/libcrypto.so*")
	gd.arrCmds.append("rm -f /usr/lib/safedog/libssl.so*")
	gd.arrCmds.append("cp %s /usr/lib/safedog/libcrypto.so"%(gd.filelibcryptopath))
	gd.arrCmds.append("cp %s /usr/lib/safedog/libssl.so"%(gd.filelibsslpath))
	gd.arrCmds.append("ln -s /usr/lib/safedog/libcrypto.so /usr/lib/safedog/libcrypto.so.6")
	gd.arrCmds.append("ln -s /usr/lib/safedog/libcrypto.so /usr/lib/safedog/libcrypto.so.0.9.8")
	gd.arrCmds.append("ln -s /usr/lib/safedog/libcrypto.so /usr/lib/safedog/libcrypto.so.1.0.0")
	gd.arrCmds.append("ln -s /usr/lib/safedog/libssl.so /usr/lib/safedog/libssl.so.6")
	gd.arrCmds.append("ln -s /usr/lib/safedog/libssl.so /usr/lib/safedog/libssl.so.0.9.8")
	gd.arrCmds.append("ln -s /usr/lib/safedog/libssl.so /usr/lib/safedog/libssl.so.1.0.0")
	gd.arrCmds.append("rm -f /usr/lib/safedog/libcurl.so.3")
	gd.arrCmds.append("ln -s /usr/lib/udcenter/libcurl.so.3 /usr/lib/safedog/libcurl.so.3")
	gd.arrCmds.append("rm -f /usr/lib/safedog/libcurl.so")
	gd.arrCmds.append("ln -s /usr/lib/udcenter/libcurl.so.3 /usr/lib/safedog/libcurl.so")

	gd.arrCmds.append("chmod -R 700 /usr/lib/safedog")
	gd.arrCmds.append("chmod -R 700 /usr/lib/udcenter")
	gd.arrCmds.append("chmod -R 700 /etc/safedog")

	gd.sConfFile="/etc/sdsvrd.conf"
	gd.sConfFileBak="/etc/safedog/backup/sdsvrd.conf.bak"

	return True



def findcrypto64():
	filecrypto = ""
	filetest = ""
	findfile = False
	if( not findfile):
		filettest = "/usr/lib64/libcrypto.so.6"
		if ( os.path.isfile(filetest) and (not os.path.islink(filetest)) and (not os.path.isdir(filetest))):
			findfile = True
	if( not findfile):
		filettest = "/lib64/libcrypto.so.6"
		if ( os.path.isfile(filetest) and (not os.path.islink(filetest)) and (not os.path.isdir(filetest))):
			findfile = True


	if( not findfile):
		sAllLibs = ""
		sOut,sErr = fPopen("ls /usr/lib64/libcrypto.so.0.9.8*")
		sAllLibs += sOut
		sOut,sErr = fPopen("ls /lib64/libcrypto.so.0.9.8*")
		sAllLibs += sOut
		sOut,sErr = fPopen("ls /usr/lib64/libcrypto.so.1*")
		sAllLibs += sOut
		sOut,sErr = fPopen("ls /lib64/libcrypto.so.1*")
		sAllLibs += sOut

		arrAllLibs = sAllLibs.split("\n")
		for i in arrAllLibs:
			if ( os.path.isfile(i) and (not os.path.islink(i)) and (not os.path.isdir(i))):
				filetest = i
				findfile = True
				break;

	if( not findfile):
		sAllLibs = ""
		sOut,sErr = fPopen("find /usr/lib64/ -name libcrypto.so.0.9.8\\*")
		sAllLibs += sOut
		sOut,sErr = fPopen("find /lib64/ -name libcrypto.so.0.9.8\\*")
		sAllLibs += sOut
		sOut,sErr = fPopen("find /usr/lib64/ -name libcrypto.so.1\\*")
		sAllLibs += sOut
		sOut,sErr = fPopen("find /lib64/ -name libcrypto.so.1\\*")
		sAllLibs += sOut
		sOut,sErr = fPopen("find /usr/lib64/ -name libcrypto.so.\\*")
		sAllLibs += sOut
		sOut,sErr = fPopen("find /lib64/ -name libcrypto.so.\\*")
		sAllLibs += sOut
		sOut,sErr = fPopen("find /usr/lib64/ -name libcrypto.so")
		sAllLibs += sOut
		sOut,sErr = fPopen("find /lib64/ -name libcrypto.so")
		sAllLibs += sOut

		arrAllLibs = sAllLibs.split("\n")
		for i in arrAllLibs:
			if ( os.path.isfile(i) and (not os.path.islink(i)) and (not os.path.isdir(i))):
				filetest = i
				findfile = True
				break;


	if(findfile):
		filecrypto = filetest

	return filecrypto


def findssl64():
	filessl = ""
	filetest = ""
	findfile = False
	if( not findfile):
		filettest = "/usr/lib64/libssl.so.6"
		if ( os.path.isfile(filetest) and (not os.path.islink(filetest)) and (not os.path.isdir(filetest))):
			findfile = True
	if( not findfile):
		filettest = "/lib64/libssl.so.6"
		if ( os.path.isfile(filetest) and (not os.path.islink(filetest)) and (not os.path.isdir(filetest))):
			findfile = True


	if( not findfile):
		sAllLibs = ""
		sOut,sErr = fPopen("ls /usr/lib64/libssl.so.0.9.8*")
		sAllLibs += sOut
		sOut,sErr = fPopen("ls /lib64/libssl.so.0.9.8*")
		sAllLibs += sOut
		sOut,sErr = fPopen("ls /usr/lib64/libssl.so.1*")
		sAllLibs += sOut
		sOut,sErr = fPopen("ls /lib64/libssl.so.1*")
		sAllLibs += sOut

		arrAllLibs = sAllLibs.split("\n")
		for i in arrAllLibs:
			if ( os.path.isfile(i) and (not os.path.islink(i)) and (not os.path.isdir(i))):
				filetest = i
				findfile = True
				break;

	if( not findfile):
		sAllLibs = ""
		sOut,sErr = fPopen("find /usr/lib64/ -name libssl.so.0.9.8\\*")
		sAllLibs += sOut
		sOut,sErr = fPopen("find /lib64/ -name libssl.so.0.9.8\\*")
		sAllLibs += sOut
		sOut,sErr = fPopen("find /usr/lib64/ -name libssl.so.1\\*")
		sAllLibs += sOut
		sOut,sErr = fPopen("find /lib64/ -name libssl.so.1\\*")
		sAllLibs += sOut
		sOut,sErr = fPopen("find /usr/lib64/ -name libssl.so.\\*")
		sAllLibs += sOut
		sOut,sErr = fPopen("find /lib64/ -name libssl.so.\\*")
		sAllLibs += sOut
		sOut,sErr = fPopen("find /usr/lib64/ -name libssl.so")
		sAllLibs += sOut
		sOut,sErr = fPopen("find /lib64/ -name libssl.so")
		sAllLibs += sOut

		arrAllLibs = sAllLibs.split("\n")
		for i in arrAllLibs:
			if ( os.path.isfile(i) and (not os.path.islink(i)) and (not os.path.isdir(i))):
				filetest = i
				findfile = True
				break;


	if(findfile):
		filessl = filetest

	return filessl






def findcrypto():
	filecrypto = ""
	filetest = ""
	findfile = False
	if( not findfile):
		filettest = "/usr/lib/libcrypto.so.6"
		if ( os.path.isfile(filetest) and (not os.path.islink(filetest)) and (not os.path.isdir(filetest))):
			findfile = True
	if( not findfile):
		filettest = "/lib/libcrypto.so.6"
		if ( os.path.isfile(filetest) and (not os.path.islink(filetest)) and (not os.path.isdir(filetest))):
			findfile = True


	if( not findfile):
		sAllLibs = ""
		sOut,sErr = fPopen("ls /usr/lib/libcrypto.so.0.9.8*")
		sAllLibs += sOut
		sOut,sErr = fPopen("ls /lib/libcrypto.so.0.9.8*")
		sAllLibs += sOut
		sOut,sErr = fPopen("ls /usr/lib/libcrypto.so.1*")
		sAllLibs += sOut
		sOut,sErr = fPopen("ls /lib/libcrypto.so.1*")
		sAllLibs += sOut

		arrAllLibs = sAllLibs.split("\n")
		for i in arrAllLibs:
			if ( os.path.isfile(i) and (not os.path.islink(i)) and (not os.path.isdir(i))):
				filetest = i
				findfile = True
				break;

	if( not findfile):
		sAllLibs = ""
		sOut,sErr = fPopen("find /usr/lib/ -name libcrypto.so.0.9.8\\*")
		sAllLibs += sOut
		sOut,sErr = fPopen("find /lib/ -name libcrypto.so.0.9.8\\*")
		sAllLibs += sOut
		sOut,sErr = fPopen("find /usr/lib/ -name libcrypto.so.1\\*")
		sAllLibs += sOut
		sOut,sErr = fPopen("find /lib/ -name libcrypto.so.1\\*")
		sAllLibs += sOut
		sOut,sErr = fPopen("find /usr/lib/ -name libcrypto.so.\\*")
		sAllLibs += sOut
		sOut,sErr = fPopen("find /lib/ -name libcrypto.so.\\*")
		sAllLibs += sOut
		sOut,sErr = fPopen("find /usr/lib/ -name libcrypto.so")
		sAllLibs += sOut
		sOut,sErr = fPopen("find /lib/ -name libcrypto.so")
		sAllLibs += sOut

		arrAllLibs = sAllLibs.split("\n")
		for i in arrAllLibs:
			if ( os.path.isfile(i) and (not os.path.islink(i)) and (not os.path.isdir(i))):
				filetest = i
				findfile = True
				break;


	if(findfile):
		#sOut,sErr = fPopen("file -L %s | awk '{print $3}'"%filetest)
		#if(int(sOut[0:2]) == gd.longbit):
		filecrypto = filetest

	return filecrypto


def findssl():
	filessl = ""
	filetest = ""
	findfile = False
	if( not findfile):
		filettest = "/usr/lib/libssl.so.6"
		if ( os.path.isfile(filetest) and (not os.path.islink(filetest)) and (not os.path.isdir(filetest))):
			findfile = True
	if( not findfile):
		filettest = "/lib/libssl.so.6"
		if ( os.path.isfile(filetest) and (not os.path.islink(filetest)) and (not os.path.isdir(filetest))):
			findfile = True


	if( not findfile):
		sAllLibs = ""
		sOut,sErr = fPopen("ls /usr/lib/libssl.so.0.9.8*")
		sAllLibs += sOut
		sOut,sErr = fPopen("ls /lib/libssl.so.0.9.8*")
		sAllLibs += sOut
		sOut,sErr = fPopen("ls /usr/lib/libssl.so.1*")
		sAllLibs += sOut
		sOut,sErr = fPopen("ls /lib/libssl.so.1*")
		sAllLibs += sOut

		arrAllLibs = sAllLibs.split("\n")
		for i in arrAllLibs:
			if ( os.path.isfile(i) and (not os.path.islink(i)) and (not os.path.isdir(i))):
				filetest = i
				findfile = True
				break;

	if( not findfile):
		sAllLibs = ""
		sOut,sErr = fPopen("find /usr/lib/ -name libssl.so.0.9.8\\*")
		sAllLibs += sOut
		sOut,sErr = fPopen("find /lib/ -name libssl.so.0.9.8\\*")
		sAllLibs += sOut
		sOut,sErr = fPopen("find /usr/lib/ -name libssl.so.1\\*")
		sAllLibs += sOut
		sOut,sErr = fPopen("find /lib/ -name libssl.so.1\\*")
		sAllLibs += sOut
		sOut,sErr = fPopen("find /usr/lib/ -name libssl.so.\\*")
		sAllLibs += sOut
		sOut,sErr = fPopen("find /lib/ -name libssl.so.\\*")
		sAllLibs += sOut
		sOut,sErr = fPopen("find /usr/lib/ -name libssl.so")
		sAllLibs += sOut
		sOut,sErr = fPopen("find /lib/ -name libssl.so")
		sAllLibs += sOut

		arrAllLibs = sAllLibs.split("\n")
		for i in arrAllLibs:
			if ( os.path.isfile(i) and (not os.path.islink(i)) and (not os.path.isdir(i))):
				filetest = i
				findfile = True
				break;


	if(findfile):
		#sOut,sErr = fPopen("file -L %s | awk '{print $3}'"%filetest)
		#if(int(sOut[0:2]) == gd.longbit):
		filessl = filetest


	return filessl


def stepnow():
	global gd
	gd.iStepNow += 1
	return str(gd.iStepNow)
	



if __name__ == "__main__":
	main()
	sys.exit(0)

